<?php
class AdminCtrl extends Ctrl{ 
    function init($name){ 
        parent::init($name);
        $this->createHidden(true);
        $this->setS('pop', NULL);
        $this->update_list 	= true; 
        $this->delete_list 	= true; 
        $this->columns 		= array();
        $this->label 		= '';
        $this->createHidden(true, array('id'));
    }
    
    function createHidden($default, $add = array()){
    	$default 			= $default ? array('id', 'created_at', 'updated_at') : array();
    	$hidden 			= array_merge($default, $add);
    	$this->hidden 		= array_combine($hidden, $hidden);
    	$this->list_hidden 	= array_combine($add, $add);
    }
    
    function onInsert(){ return $this->listAll(); }
	function onUpdate(){ return $this->listAll(); }
	function onDelete(){ return $this->listAll(); }
    
	function assignUpdateDelete($hide = true, $hide_with = array()){
		$this->assign('update', $this->update_list); 
    	$this->assign('delete', $this->delete_list);
    	$this->assignRelations($hide, $hide_with);
	}
	
	function paginate(){
		$this->assignUpdateDelete(false);
		return parent::paginate('arrWithRelations', array(true, $this->list_hidden));
	}
	
	function assignHidden($hide = true){
		$this->assign('hide', $hide);
    	$this->assign('list_hidden', $this->list_hidden);
    	$this->assign('hidden', $this->hidden);
	}
	
    function listAll(){
    	$this->goRetUrl();
    	$this->checkLogin();
    	$this->assignUpdateDelete(true, $this->list_hidden);
    	$this->assignHidden();
    	$this->assign('items', $this->arrWithRelations($this->findAll()));
    	return $this->fetch('../list.tpl');
	}
	
	function createPop($hide = true){ 
	  $record     	= $this->find(); 
	  $pop         	= $record->toArray();
	  foreach($this->t->getRelations() as $key => $value){
		  if($value instanceof Doctrine_Relation_Association){
			if($hide){
				if(!in_array($key, $this->hidden))
					$pop[$key] 	= $record->fluent2d($key)->flatten('id')->c; 
			}else
				$pop[$key] 	= $record->fluent2d($key)->flatten('id')->c;
		  }
	  }
	  return $pop; 
	}
	
	function search($post = NULL, $as_query = false){
		$this->checkLogin();
		return parent::search($post, $as_query);
	}
	
	function uForm(){ 
	  $this->checkLogin();
	  $this->setS('pop', $this->createPop()); 
	  return parent::uForm(); 
	}
	
	function isListHidden($field){
		if($this->getTplVar('hidden')){
			if(in_array($field, $this->list_hidden))
				return true;
		}
		return false;
	}
	
	function arrWithRelations($collection, $hide = true){
		$rarr = array();
		foreach($collection as $item){
			$rarr[$item->id] = $item->toArray();
			foreach($this->t->getRelations() as $key => $value){
				$ctrl = $this->getCtrl( $value->getClass() );
				if($this->isListHidden($key) == false){
					if($value instanceof Doctrine_Relation_Association)
						$rarr[$item->id][$key] = $item->fluent2d($key)->flatten( $ctrl->label )->join('<br/>')->c;
					else if($value instanceof Doctrine_Relation_LocalKey)
						$rarr[$item->id][$value->getLocal()] = $item->fluent($key)->at($ctrl->label);
				}
			}
		}
		return $rarr;
	}
	
	function assignRelations($hide = true, $hide_with = array()){
		$hide_with = empty($hide_with) ? $this->hidden : $hide_with;
		foreach($this->t->getRelations() as $key => $value){
			if($value instanceof Doctrine_Relation_Association){
				$relations[ $key ]['foreign'] = true;
				$this->columns += array($key => array());
			}else if($value instanceof Doctrine_Relation_LocalKey)
				$key = $value->getLocal();
			
			$relations[ $key ]['label'] = $this->getCtrl($value->getClass())->label;
			$relations[ $key ]['Mdl'] 	= $value->getClass();
		}
		$this->assign('relations', $relations);
		$columns = $hide ? array_diff_key($this->t->getColumns(), $hide_with) : $this->t->getColumns();
		$this->assign('columns', $columns + $this->columns);
	}
	
	function getLbl($p, &$s){ 
	  return $this->getCtrl($p['mdl'])->label; 
	}
	
	function save(){
		$this->checkLogin();
		return parent::save();
	}
	
	function form(){
		$this->setRetUrl();
		$this->checkLogin();
		$this->setS('pop', NULL);
		return parent::form();
	}
	
	function formCommon($f_head, $type, $tpl = '../ui.tpl'){
		$this->assignRelations();
		$this->assignHidden();
		return parent::formCommon($f_head, $type, $tpl);
	}
	
	function checkLogin(){
		if($this->getS('logged_in', 'admin') !== true){
			$this->assign('login_error', 'You have to login.');
			echo $this->login();
			exit;
		}
	}
	
	function login(){ 
		return $this->fetch('../login_form.tpl');
	}
	
	function logout(){ 
		$this->setS('logged_in', false, 'admin');
		return $this->fetch('../login_form.tpl');
	}
	
	function searchForm(){
		$this->assignRelations(false);
		$this->assignHidden(false);
		return $this->fetch('../search_form.tpl');
	}
}
