<?php
class Ctrl{
	function __construct(){}
	
	function init($name){
		$this->name			= $name;
		$this->g			= $_GET;
		$this->site_dir		= empty($GLOBALS['base_dir']) ? "/" : "/{$GLOBALS['base_dir']}/";
		$this->base_dir		= $this->site_dir.$this->name."/";
		$this->lang			= $_SESSION['lang'];
		$this->smarty 		= new SmartyDoctrine();
		$this->q			= Doctrine_Query::create();
		$this->t			= $this->getT($this->name);
		$this->p	   		= $_POST;
		$this->template		= $this->name.".tpl";
		$this->config_file  = $this->lang.$this->name.".conf";
		
		$this->assign('config_file', 	$this->config_file);
		$this->assign('base_dir', 		$this->base_dir);
		$this->assign('site_dir', 		$this->site_dir);
		$this->regObj("tObj", 			$this->t);
		$this->regObj("obj", 			$this);
	}
	
	function tblName()				{ return strtolower($this->name); }
	function db()					{ return $GLOBALS['doctrine_db']; }
	function dcManager()			{ return $GLOBALS['doctrine_manager']; }
	function setS($key, $value, $name = false){
		$name = !$name ? $this->name : $name; 
		$_SESSION[$name][$key] = $value; 
	}
	function getS($key, $name = false){
		$name = !$name ? $this->name : $name; 
		return $_SESSION[$name][$key]; 
	}
	function findAll()				{ return $this->t->findAll(); }
	function findAllArr()			{ return $this->findAll()->toArray(); }
	function findObjAssoc($key)		{ return Common::assocObj($this->findAll(), $key); }
	function getActionUrl($action)	{ return "{$this->dir}/{$this->name}/$action"; }
	function getFormHead($action)	{ return 'method="POST" enctype="multipart/form-data" action="'.$this->base_dir.$action.'"'; }
	function fetchMe($alias = 'me')	{ return $this->t->createQuery($alias); }
	function getG($key)				{ return $GLOBALS[$key]; }
	function from($extra = '')		{ return $this->q->from($this->name." this ".$extra); }
	
	function setRetUrl(){ 
		if(!empty($this->g['retUrl']))
			$this->setS('ret_url', str_replace('+', '/', $this->g['retUrl']));
	}
	
	function goRetUrl(){
		if($this->getS('ret_url') != NULL)
			header("Location: http://".$_SERVER['HTTP_HOST'].$this->base_dir.$this->getS('ret_url'));
		$this->setS('ret_url', NULL);
	}
	
	function searchForm()	{ return $this->formCommon('search', '', 'search_form.tpl'); }
	function form()		 	{ return empty($this->g['id']) ? $this->iForm() : $this->uForm(); }
	function iForm()		{ return $this->formCommon('save', 'insert'); }
	
	function getQ($field = false, $value = false, $order = false, $limit = false){ 
		$q = $this->t->createQuery();
		if($field == false) 
			return $q;
		$q->where("$field = ?", array($value));
		if($order)	$q->orderBy($order);
		if($limit)	$q->limit($limit);
		return $q;
	}
	
	function findBy($field, $value, $order = false, $limit = false){			
		return $this->getQ($field, $value, $order, $limit)->execute();
	}
	
	function beforeUpdateForm(){ }
	function uForm(){
		$this->setS('pop', $this->hasPop() ? $this->getS('pop') : $this->find()->toArray());
		$this->beforeUpdateForm();
		return $this->formCommon('save/id/'.$this->g['id'], 'update');
	}
	
	function formCommon($f_head, $type, $tpl = "ui_form.tpl"){
		$this->assign('form_head', $this->getFormHead($f_head));
		$this->assign('type', $type);
		$tpl = empty($this->ui_tpl) ? $tpl : $this->ui_tpl;
		return $this->fetch($tpl);
	}
	
	function search($post = NULL, $as_query = false){
		$p		= empty($post) ? $this->p : $post;
		$p 		= Arr::fluent($p)->trim()->c;
		$dql 	= '';
		$arr 	= array();
		$first	= true;
		foreach($p as $key => $value){
			$dql .= $first ? '' : ' AND ';
			if(array_key_exists($key, $this->obj->searchConf)){
				$dql 	.= $this->obj->searchConf[$key]['where'];
				$arr[] 	 = str_replace('?', $value, $this->obj->searchConf[$key]['value']);
			}else{
				$type = is_array($value) ? 'array' : Arr::fluent($this->t->getDefinitionOf($key))->at('type');
				switch($type){
					case 'array':
						$tmp = '.id IN (?)';
						$arr[] = implode(',', $value);
						break;
					case 'string':
						$tmp = ' LIKE ?';
						$arr[] = "%$value%";
						break;
					case 'timestamp':
						$tmp = ' > ?';
						$arr[] = $value;
						break;
					default:
						$tmp = ' = ?';
						$arr[] = $value;
						break;
				}
				$dql .= "this.$key".$tmp;
			}
			$first	 = false;
		}
		
		if(!empty($arr)){
			$query = $this->from()->where($dql, $arr);
			return $as_query ? $query : $query->execute()->toArray();
		}else
			return $as_query ? $this->t->createQuery() : $this->findAllArr();
	}
	
	function paginate($func = false, $params = array(), $tpl = '../search_result.tpl'){
		$this->obj	= $this->myMdl();
		if($this->g['start'] == 1)
			$this->setS('query', '');
			
		$cur_page 	= empty($this->g['page']) ? 1 : $this->g['page'];
		$query 		= $this->getS('query');
		
		if(empty($query)){								
			$query = $this->search(NULL, true);
			$this->setS('query', $query);
		}
		
		$pager 			= new Doctrine_Pager($query, $cur_page, $this->obj->pageConf['per_page']);
		$pager_range 	= $pager->getRange($this->obj->pageConf['page_style'], array('chunk' => $this->obj->pageConf['per_chunk']));
		$pager_layout 	= new Doctrine_Pager_Layout($pager, $pager_range, $this->base_dir.'paginate/page/{%page_number}');
		$pager_layout->setTemplate('[<a href="{%url}">{%page}</a>]');
		$pager_layout->setSelectedTemplate('[{%page}]');
		
		$this->assign('cur_page', $cur_page);
		
		$items = !$func ? $pager->execute()->toArray() : call_user_func_array(array(&$this, $func), array_merge(array($pager->execute()), $params));
		$this->assign('items', $items);
		$this->assign('pagination', $pager_layout->display(array(), true));
		return $this->fetch($tpl);
	}
	
	function setErrQuit($key, $error){
		$this->setS('pop', $this->p);
		$this->error = array($key => $this->getConfig('errors', $error));
		return $this->form();
	}
	
	function onSave(){
		$this->setS('pop', NULL);
		if(empty($this->g['id'])) 	return $this->onInsert();
		else						return $this->onUpdate();
	}
	
	function onInsert(){ return "The object has been saved."; }
	function onUpdate(){ return "The object has been updated."; }
	function onDelete(){ return "The object has been deleted."; }
	
	function getBodyExt($key, $info){
		$inf = $info['new_name'][$key]; 
		if(is_array($inf))
			return call_user_func_array($inf['func'], $inf['params']);
		return $inf;
	}
		
	function getFilePath($key, $folder, $file_name = ''){
		if(empty($_FILES[$key]['name']))
			return '';
		$file_name = empty($file_name) ? $_FILES[$key]['name'] : $file_name;
		return $folder."/".$file_name;
	}
		
	function delete(){
		$obj = $this->find();
		if(!empty($obj->files)){
			foreach($obj->files as $file => $info){
				if(is_file($obj->$file))
					unlink($obj->$file);
			}
		}
		$obj->delete();
		return $this->onDelete();
	}
	
	function beforeSave(&$obj){}
	
	function save($validate = true){
		$custom_validation = $this->validation();
		if($custom_validation !== true){
			list($key, $error) = $custom_validation;
			return $this->setErrQuit($key, $error);
		}
		$obj = empty($this->g['id']) ? $this->myMdl() : $this->find();
		try{
			$obj->fromArrayExt($this->p);
			$this->beforeSave($obj);
			$obj->save();
			$this->afterSave($obj);
			return $this->onSave();
		}catch(Doctrine_Validator_Exception $e){
			if($validate == 'debug'){
				print_r($obj->getErrorStack()->toArray());
				exit;
			}else if($validate){
				foreach($obj->getErrorStack()->toArray() as $key => $value)
					return $this->setErrQuit($key, $value[0]);
			}
		}
	}
	
	function afterSave(&$obj){
		if(!empty($obj->files)){
			foreach($obj->files as $file => $info){
				if(!empty($info['new_name'])){
					$body 		= $this->getBodyExt('body', $info);
					$ext 		= $this->getBodyExt('extension', $info);
					$new_name 	= empty($ext) ? $body : $body.'.'.$ext;
				}else
					$new_name 	= '';
					
				$path 			= $this->getFilePath($file, $info['folder'], $new_name);
				$upload 		= Arr::fluent($info['upload']);
				$func 			= $upload->shift();
				$params 		= $upload->unshift($path, $file)->c;
				if(call_user_func_array(array($this, $func), $params)){
					if(is_file($obj->$file))
						unlink($obj->$file);
					$obj->$file = $path;
				}
			}
			$obj->save();
		}
	}
	
	function validation(){ return true; }
	
	function hasPop(){
		$tmp = $this->getS('pop');
		return empty($tmp) ? false : true;
	}
	
	function getPop($key){
		$tmp = $this->getS('pop');
		return $tmp[$key];
	}
	
	function selBoxEmpty($p, &$s){ return $this->selBox($p, $s, true); }
	
	function selBox($p, &$s, $empty = false){
		$kname 			= empty($p['val']) ? 'id' : $p['val'];
		$p['options'] 	= $this->tKeyVal($p['mdl'], $kname, $p['lbl']);
		if($empty)
			array_unshift($p['options'], $this->getConfig(false, 'please_select', $_SESSION['lang'].'General.conf'));
		return $this->commonBox($p, 'sel_box.tpl');
	}
	
	function checkBoxes($p, &$s){
		$kname 			= empty($p['val']) ? 'id' : $p['val'];
		$p['options'] 	= $this->tKeyVal($p['mdl'], $kname, $p['lbl']);
		return $this->commonBox($p, 'checkboxes.tpl');
	}
	
	function radioBox($p, &$s){
		return $this->commonBox($p, 'radio_box.tpl', $p['popfrom']);
	}
	
	function checkBox($p, &$s){
		return $this->commonBox($p, 'check_box.tpl');
	}
	
	function textBox($p, &$s){
		$p['type'] = empty($p['pwd']) ? 'text' : 'password';
		return $this->commonBox($p, 'text_box.tpl', $p['popfrom']);
	}
	
	function fileBox($p, &$s){ return $this->commonBox($p, 'file_box.tpl', $p['popfrom']); }
	function textArea($p, &$s){ return $this->commonBox($p, 'text_area.tpl'); }
	
	function commonBox($p, $tpl, $pop = false){
		$s = new SmartyDoctrine();
		$s->assign('error', $this->error[$p['idname']]);
		$s->assign('prepop', !$pop ? $this->getPop($p['idname']) : $this->getPop($pop));
		$s->assign($p);
		return $s->fetch($tpl, false);
	}
	
	function regObj($name, &$obj, $arr = array(), $pass = true){ 
		$this->smarty->register_object($name, $obj, $arr, $pass); 
	}
	
	function tKeyVal($m, $keyname, $valname){ return Common::keyValue($this->tAllArr($m), $keyname, $valname); }
	
	function tAllArr($m, $asArr = true){
		$arr = $this->getT($m)->findAll();
		return $asArr ? $arr->toArray() : $arr;
	}
	
	function getT($m){ return Doctrine::getTable($m); }
	
	function find($id = NULL){
		if(empty($id))
			return empty($this->g['id']) ? $this->t->find($this->p['id']) : $this->t->find($this->g['id']);
		else
			return $this->t->find($id);
	}
	
	function display($template = false, $folder = false){ echo $this->fetch($template, $folder); }
	
	function fetch($template = false, $folder = false){
		if($template == false){
			$this->smarty->template_dir .= "/".$this->name;			
			return $this->smarty->fetch($this->template);
		}else{
			if($folder !== null){
				if($folder == false) 	$this->setSmartyTplDir($this->name);
				else					$this->setSmartyTplDir($folder);
			}
			return $this->smarty->fetch($template);
		}
	}
	
	function setSmartyTplDir($addition){
		$dir_arr = explode("/", $this->smarty->template_dir);
		if($addition != array_pop($dir_arr))
			$this->smarty->template_dir .= "/".$addition;
	}
	
	function assign($key, $value = false){
		if(is_array($key))	$this->smarty->assign($key);
		else				$this->smarty->assign($key, $value);
	}
	
	function assign_by_ref($key, $value = false){
		if(is_array($key))	$this->smarty->assign_by_ref($key);
		else				$this->smarty->assign_by_ref($key, $value);
	}
	
	function getConfig($section = false, $variable = false, $config_file = false){
		$config_file = $config_file == false ? $this->config_file : $config_file;
		
		if(!is_file("configs/$config_file"))
			return '';
		
		if($section == false)	$this->smarty->config_load($config_file);
		else					$this->smarty->config_load($config_file, $section);
			
		if($variable == false)	return $this->smarty->get_config_vars();
		else					return $this->smarty->get_config_vars($variable);
	}
	
	function getTplVar($var){ return $this->smarty->get_template_vars($var); }
	
	function emptyTplVar($var){
		$result = $this->getTplVar($var);
		if(empty($result))	return true;
		else				return false;
	}
	
	function getMdl($model){
		$model = ucfirst($model);
		return new $model;  
	}
	
	function myMdl()		{ return $this->getMdl($this->name); }
	function validateOn()	{ $this->dcManager()->setAttribute(Doctrine::ATTR_VALIDATE, Doctrine::VALIDATE_ALL);}
	function validateOff()	{ $this->dcManager()->setAttribute(Doctrine::ATTR_VALIDATE, Doctrine::VALIDATE_NONE);}
	
	function getCtrl($ctrl){ 
		$class_name = ucfirst($ctrl).'Ctrl';
		$file_name = $class_name.'.php';
		include_once($file_name);
		$obj = new $class_name;
		$obj->init(ucfirst($ctrl));
		return $obj;
	}
	
	function upload($file_path, $key){
		$move_result 		= move_uploaded_file($_FILES[$key]['tmp_name'], $file_path);
		if($move_result)	chmod($file_path, 0777);
		else				return false;
		return true;
	}
	
	function uploadImage($file_path, $key, $max_width, $max_height){
		$move_result = move_uploaded_file($_FILES[$key]['tmp_name'], $file_path);
		if($move_result){
			$result = Common::reScaleImage($file_path, $max_width, $max_height);
			if(!$result){
				unlink($file_path);
				return false;
			}else
				chmod($file_path, 0777);
		}else
			return false;
		return true;
	}
}